; Hello, World!
; (C) 2002-2005, Andreas Berg. All Rights Reserved.

.model             small               ; SMALL model
.stack             100h                ; 100h STACK
.data                                  ; Use DATA segment

; Messages
TimePrompt            db  "Is it after 12 noon (Y/N)?$"
GoodMorningMessage    db  13,10,"Good morning, world!",13,10,"$"
GoodAfternoonMessage  db  13,10,"Good afternoon, world!",13,10,"$"
defaultMessage        db  13,10,"Good day, world!",13,10,"$"

.code                                  ; Use CODE segment
mov        ax,@data                    ; AX = @data
mov        ds,ax                       ; DS = AX

mov        dx,offset TimePrompt        ; DX -> TimePrompt
mov        ah,9                        ; AH = 9 (DOS Print String)
int        21h                         ; INT 21h: Print the string

mov        ah,1                        ; AH = 1 (DOS Get character)
int        21h                         ; INT 21h: Get the character
or         al,20h                      ; Make lower case

cmp        al,"y"                      ; Typed "y"?
je         IsAfternoon                 ; If yes, jump to "IsAfternoon"
cmp        al,"n"                      ; Typed "n"?
je         IsMorning                   ; If yes, jump to "IsMorning"

mov        dx,offset defaultMessage    ; DX -> defaultMessage
jmp        DisplayGreeting             ; Jump to "DisplayGreeting"

IsAfternoon:
mov        dx,offset GoodAfternoonMessage     ; DX -> GoodAfternoonMessage    
jmp        DisplayGreeting             ; Jump to "DisplayGreeting"

IsMorning:
mov        dx,offset GoodMorningMessage       ; DX -> GoodMorningMessage

DisplayGreeting:
mov        ah,9                        ; AH = 9 (DOS Print String)
int        21h                         ; INT 21h: Print the string

mov        ah,4ch                      ; AH = 4ch (Terminate EXE)
mov        al,0                        ; AL = 0 (return code)
int        21h                         ; INT 21h: Terminate program

end
